'use strict';

var a = angular.module('synopassApp')
    .controller('MainCtrl', function ( $window, $scope, $route, $location, Category, Password, Context, PwdCache, Config) {

        $window.currentCat = '';
        $window.currentTag = '';
        $window.tabState = '';
        $window.masterKey = '';
		$window.nonce = '';
		$window.nonce_error = 100;
		$window.error_max_login_failure = 101;
		
        $scope.catClicked = function(catId){

            $window.currentCat =catId;
            $window.tabState = 0;

            var pwdList = PwdCache.get(catId);

            if( typeof(pwdList) != "undefined"){
                $scope.pwdList = pwdList;
            }else{
                Password.queryByCat(catId).then(function(data){
                    PwdCache.set(catId,data);
                    $scope.pwdList = data;
            });
        }
            $scope.keywordSearch = "";
        }

        $scope.ctxClicked = function(ctxId,ctxName){
            $window.tabState = 1;
            $window.currentTag =ctxId;
            $window.currentTagName = ctxName;

            var pwdList = PwdCache.get(ctxId);

            if( typeof(pwdList) != "undefined"){
                $scope.pwdList = pwdList;
            }else{
                Password.queryByTag(ctxId).then(function(data){
                    PwdCache.set(ctxId,data);
                    $scope.pwdList = data;
                });
            }
            $scope.keywordSearch = "";
        }

        $scope.editMode = function(){

            if($scope.control == "control-hide")
                $scope.control = "control-show";
            else
                $scope.control = "control-hide";

        }

        $scope.searchPwd = function(){
            $window.tabState = 2;

            Password.search($scope.keywordSearch).then(function(data){
                $scope.pwdList = data;
            });

        }

        $scope.logout = function(){
            $window.masterKey = "";
			$window.nonce = "";
            $route.reload();
        }

        $scope.control = "control-hide";

        $scope.setDefaultCategory = function(){
            $scope.$broadcast('currentCat');
        };
		
		$scope.copyToClipboard = function (text) {
			window.prompt("Copy to clipboard: Ctrl+C, Enter", text);
		}
    });


synopassApp.controller('tabSetCtrl', function($scope, $element){
    var tabs = $scope.tabs = [];
    $scope.select = function(tab){
        angular.forEach(tabs, function(tab){
            tab.selected = false;
        });
        tab.selected = true;
    }
    this.addTab = function(tab){
        if(tabs.length == 0)
            $scope.select(tab);
        tabs.push(tab);
    }

});



synopassApp.controller('catctrlCtrl', function( $scope, $element){

    $scope.$parent.$watch("control", function(newValue, oldValue){
        $scope.control = newValue;
    });

    $scope.control = $scope.$parent.control;

    $scope.catEdit = function(catId,title){

        if(catId == '00000000-0000-0000-0000-000000000000'){
            alert("Edit system category is forbidden.");
            return;
        }
        $('input#editCategoryID').val(catId);
        $('input#editCategoryName').val(title);

        $('#editCatPopup').modal('show');
    }

    $scope.catDel = function(catId,title){
        if(catId == '00000000-0000-0000-0000-000000000000'){
            alert("Delete system category is forbidden.");
            return;
        }
        $('input#delCategoryID').val(catId);
        $('span#delCategoryTitle').html(title);

        $('#delCatPopup').modal('show');
    }
});


synopassApp.controller('cateditCtrl', function( $scope, $window, Category){


    $scope.updateCat = function updateCat(){

        if(!$scope.EditCatForm.$valid)
            return;

        var json =        {
            id: $('input#editCategoryID').val(),
            name: this.cat.rel
        };

        Category.save(json,this.$parent.catList).then(function(response){
            if(response == 1){
                //successfully saved
                alert('Category updated.');
                $('div#editCatPopup').modal('hide');
            }else if(response == $window.nonce_error){
				//empty implementation
			}else if(response == $window.error_max_login_failure){
				//empty implementation
			}else{
                alert('Failed to update category, please try again later.');
            }
            return response;
        });


    }
});


synopassApp.controller('cataddCtrl', function( $scope, $window, Category){

    $scope.addCat = function addCat(catName){

        if(!$scope.AddCatForm.$valid)
            return;

        var json =        {
            name: catName
        };

        Category.save(json, this.$parent.catList, $scope)

            .then(function(response){

                if(response == 1){
                    //successfully saved
                    alert('New category created.');
                    $('div#add_cat').modal('hide');
				}else if(response == $window.nonce_error){
					//empty implementation
				}else if(response == $window.error_max_login_failure){
					//empty implementation
				}else{
                    alert('Failed to create new category, please try again later.');
                }
                return response;
            });

    }


    $scope.resetAddCatForm = function resetAddCatForm(){
        $scope.newcatname = "";
    };
});


synopassApp.controller('catdelCtrl', function( $scope, $window, Category){

    //$scope.catList = $scope.$parent.catList;
	
    $scope.$on('currentCat',function(args){
        $scope.catList = $scope.$parent.catList;
    });

    $scope.deleteCat = function deleteCat(opt,xfer){

        if($('input#delCategoryID').val() == '00000000-0000-0000-0000-000000000000'){
            alert("Delete system category is forbidden.")
            return;
        }


        var resp = Category.delete($('input#delCategoryID').val(), this.$parent.catList, opt, xfer);


    }
});


synopassApp.controller('ctxctrlCtrl', function( $scope, $window, $element){


    $scope.$parent.$watch("control", function(newValue, oldValue){
        $scope.control = newValue;
    });


    $scope.control = $scope.$parent.control;

    $scope.tagEdit = function(tagId,title){

        $('input#tagCategoryID').val(tagId);
        $('input#editTagName').val(title);

        $('#editTagPopup').modal('show');
    }

    $scope.tagDel = function(tagId,title){

        $('input#delTagID').val(tagId);
        $('span#delTagTitle').html(title);

        $('#delTagPopup').modal('show');
    }
});


synopassApp.controller('ctxeditCtrl', function( $scope, $window, Context){

    $scope.updateCtx = function updateCtx(){

        if(!$scope.EditTagForm.$valid)
            return;

        var newVal = this.ctx.rel;

        var json =        {
            id: $('input#tagCategoryID').val(),
            name: this.ctx.rel
        };

        Context.save(json,this.$parent.ctxList).then(function(response){
            if(response == 1){
                //successfully saved
                alert('Tag updated.');
                $('div#editTagPopup').modal('hide');
			}else if(response == $window.nonce_error){
					//empty implementation
			}else if(response == $window.error_max_login_failure){
					//empty implementation
            }else{
                alert('Failed to update tag, please try again later.');
            }
        });


    }
});


synopassApp.controller('ctxdelCtrl', function( $scope, $window, Context){

    $scope.deleteCtx = function deleteCtx(){

        var delId = $('input#delTagID').val();


        var resp = Context.delete(delId, this.$parent.ctxList, this.$parent.pwdList);

    }
});


synopassApp.controller('ctxaddCtrl', function( $scope, $window, Context){

    $scope.addCtx = function addCtx(ctxName){

        if(!$scope.AddTagForm.$valid)
            return;

        var json =        {
            name: ctxName
        };

        Context.save(json, this.$parent.ctxList, $scope).then(function(response){
            if(response == 1){
                //successfully saved
                alert('New tag created.');
                $('div#add_ctx').modal('hide');
			}else if(response == $window.nonce_error){
					//empty implementation
			}else if(response == $window.error_max_login_failure){
					//empty implementation
            }else{
                alert('Failed to create new tag, please try again later.');
            }
        });
    }

    $scope.resetAddTagForm = function resetAddTagForm(){
        $scope.newctxname = "";
    }
});



synopassApp.controller('pwdctrlCtrl', function( $scope, $window, $element){

    $scope.$parent.$watch("control", function(newValue, oldValue){
        $scope.control = newValue;
    });

    $scope.control = $scope.$parent.control;

    $scope.pwdDel = function(pwdId, title, catId){
        $('input#delPasswordID').val(pwdId);
        $('input#delPasswordCatID').val(catId);
        $('span#delPasswordTitle').html(title);

        $('#pwdDeletePopup').modal("show");
    }

    $scope.pwdEdit = function(obj){
        $scope.$emit('editFormUpdate', obj);

    }
});




synopassApp.controller('pwdeditCtrl', function( $scope, $window, Password, Category, PasswordContext, PwdCache){

    $scope.$on('editFormUpdate', function(event,args){

        $scope.rel = args.pwd_id;
        $scope.title = args.pwd_title;
        $scope.pwd = args.pwd_pwd;
        $scope.cat = args.pwd_cat;
        $scope.orgCat = args.pwd_cat;
        $scope.login = args.pwd_login;
        $scope.url = args.pwd_url;
        $scope.notes = args.pwd_notes;
        $scope.context = args.ctx_name;
        $scope.pwdObj = args;
        if($scope.context != null){
            cl = $scope.context.split(" ");
            $scope.tagList = cl;
        }else{
            $scope.tagList = "";
        }

        $('div#pwdEditPopup').modal("show");
    });

    $scope.catList = $scope.$parent.catList;
    $scope.ctxList = $scope.$parent.ctxList;

    var cl = null;




    $scope.disconnectCtx = function disconnectCtx(pwdId,tag,tagList){
        PasswordContext.delete(pwdId,tag,tagList).then(function(data){
            if(data.response == 1){
                //update root pwdList entry
                $scope.pwdObj.ctx_name=tagList.toString().replace(/,+/g," ");

                //remove password from current pwd list view
                var idx = 0;
                var notBreak = true;
                if($window.tabState == 1 && $window.currentTagName == tag){
                    angular.forEach($scope.pwdList, function(value, key){
                        if(notBreak && value.pwd_id == pwdId){
                            $scope.pwdList.splice(idx, 1);
                            notBreak = false;
                        }
                        idx++;
                    });
                }

                //invalidate cache
                notBreak = true;
                angular.forEach($scope.ctxList, function(value, key){
                    if(notBreak && value.ctx_name == tag){
                        PwdCache.invalidate(value.ctx_id);
                        notBreak = false;
                    }
                });

            }
        });
    }

    $scope.updatePwd = function updatePwd(pwdId,title,pwd,cat,login,url,notes,icon,context,tagList,orgCat){

        if(!$scope.EditPwdForm.$valid)
            return;

        var json =        {
            id: pwdId,
            p: $window.masterKey,
			n: $window.nonce,
            c: cat,
            t: title,
            l: login,
            u: url,
            o: notes,
            ctx: context,
            k: pwd
        };

        Password.save(json,$scope.pwdList,$scope.ctxList,$scope,tagList).then(function(response){

            if(response == 1){
                //successfully saved
                alert('Password updated.');

                if(orgCat != cat){
                    //category changed, update password list and invalidate cache
                    var notBreak = true;
                    var idx = 0;
                    angular.forEach($scope.pwdList, function(value, key){
                        if(notBreak && value.pwd_id == pwdId){
                            $scope.pwdList.splice(idx, 1);
                            notBreak = false;
                        }
                        idx++;
                    });
                    PwdCache.invalidate(orgCat);
                    PwdCache.invalidate(cat);
                }
                $scope.resetUpdatePwdForm();
                $("div#pwdEditPopup").modal('hide');
			}else if(response == $window.nonce_error){
					//empty implementation
			}else if(response == $window.error_max_login_failure){
					//empty implementation
            }else{
				alert('Failed to update password, please try again later.');
            }
        });


    };


    $scope.resetUpdatePwdForm = function resetUpdatePwdForm(){

        $("#ULTags").tagit("removeAll");

        $("input[name=editTags]").val('');

    };
});



synopassApp.controller('pwddelCtrl', function( $scope, $window, Password, PwdCache){

    $scope.deletePwd = function deletePwd(){

        var pwdId = $('input#delPasswordID').val();
        var catId = $('input#delPasswordCatID').val();

        Password.delete(pwdId,this.$parent.pwdList).then(function(data){
            if(data.response == 1){
                PwdCache.invalidate(catId);

                var tags = data.tags;

                $.each(tags, function(i,val){
                    PwdCache.invalidate(val.ctx_id);
                });
            }
        });



    }


});


synopassApp.controller('pwdaddCtrl', function( $scope, $window, Password, PwdCache){

    $scope.$on('currentCat',function(args){
        $scope.cat = $window.currentCat;
        $scope.catList = $scope.$parent.catList;
    });



    $scope.addPwd = function addPwd(title,pwd,cat,login,url,notes, isCreateNext){

        if(!$scope.AddPwdForm.$valid)
            return;




        var tags = new Array();

        $("input[name=newTags]").each(function(){
            var tag_name = $(this).val();
            tags.push(tag_name);
        });

        //create a new password record
        var json  = {
            t: title,
            p: $window.masterKey,
			n: $window.nonce,
            c: cat,
            l: login,
            u: url,
            o: notes,
            k: pwd
            //tags: tags
        }

        // console.log(json);

        var l_pwdList;

        if(typeof $scope.$parent.pwdList != 'undefined')
            l_pwdList = $scope.$parent.pwdList;

        Password.save(json, l_pwdList, $scope.$parent.ctxList, $scope,null).then(function(response){
            if(response == 1){
                //successfully saved
                alert('New password created.');
                //invalidate cache
                PwdCache.invalidate(cat);
                $.each(tags, function(i,val){
                    $.each($scope.$parent.ctxList, function(j,jval){
                        if(val == jval.ctx_name){
                            PwdCache.invalidate(jval.ctx_id);
                        }
                    });

                });



                if(isCreateNext){
                    $scope.resetAddPwdForm(true);
                }else{
                    $('div#add_pwd').modal('hide');
                }
			}else if(response == $window.nonce_error){
					//empty implementation
			}else if(response == $window.error_max_login_failure){
					//empty implementation
            }else{
                alert('Failed to create new password, please try again later.');
            }
        });


    };

    $scope.resetAddPwdForm = function resetAddForm(isIgnoreCat){

        $scope.title = "";
        $scope.pwd = "";
        if(!isIgnoreCat){
            $scope.cat = "";
        }
        $scope.login = "";
        $scope.url = "";
        $scope.notes = "";
        $scope.newtag = "";
        $('#ULTagsNew').tagit("removeAll");
    };
});


synopassApp.controller('setupCtrl', function( $scope, Config){


    var is_inited = Config.isInited().then(function(resp){

        var options = {
            keyboard: false,
            backdrop: 'static',
            show: true
        }
		
		var result = resp.data;
		result = result.replace(/^[\r\n]+|\.|[\r\n]+$/g, "");
		
        if( (result == false || result == 'false')){

            $('div#setup').modal(options);
        }else{
            $('div#login').modal(options);
        }


    });

    $scope.setup = function(){
        var pass = true;
        if($scope.smasterPassword != $scope.srepeatPassword){
            pass = false;
            alert('Master password not matched');
            return;
        }


        var result = Config.save($scope.smasterPassword,$scope.sencryptKey).then(function(resp){
        });




    }
});


synopassApp.controller('loginCtrl', function( $scope, Auth, Config, Category, Context){

	$("div#two_factor").hide();

	var is_2_factor = Config.is2factor().then(function(resp){

        var options = {
            keyboard: false,
            backdrop: 'static',
            show: true
        }
		var result = resp.data;
		result = result.replace(/^[\r\n]+|\.|[\r\n]+$/g, "");
		
        if( (result === false || result == 'false')){
			$('div#two_factor').hide();
			$scope.twofactorCode='000000';
        }else{
			$('div#two_factor').show();

        }


    });
	
    $scope.login = function(){

		Config.is2factor().then(function(resp){
			var result = resp.data;
			result = result.replace(/^[\r\n]+|\.|[\r\n]+$/g, "");
		
			if( (result === false || result == 'false')){
				result = Auth.login($scope.lmasterPassword).then(function(resp){
					Category.query().then(function(data){
						$scope.$parent.catList = data;
					});

					Context.query().then(function(data){
						$scope.$parent.ctxList = data;
					});
				});
			}else{
				result = Auth.two_factor($scope.lmasterPassword,$scope.twofactorCode).then(function(resp){
					Category.query().then(function(data){
						$scope.$parent.catList = data;
					});

					Context.query().then(function(data){
						$scope.$parent.ctxList = data;
					});
				});
			}
		});

    }


});



synopassApp.controller('httpWarningCtrl', function( $scope, $location){

    var protocol = $location.protocol();

    if(protocol != 'https'){
        var options = {
            keyboard: false,
            backdrop: 'static',
            show: true
        }
        $('#httpwarning').modal(options);
        $('div#login').modal('hide');
        $('div#setup').modal('hide');
    }




});