synopassApp.directive('tabset', function(){
    return {
        restrict: 'E',
        transclude: true,
        scope: {},
        controller: 'tabSetCtrl',
        templateUrl: 'views/tabSet.html',
        replace: true
    };
});

synopassApp.directive('tab', function(){
    return {
        require: '^tabset',
        restrict: 'E',
        transclude: true,
        scope: { title: '@'},
        link: function(scope, element, attrs, tabsCtrl){
            tabsCtrl.addTab(scope);
        },
        templateUrl: 'views/tab.html',
        replace: true
    };
});


synopassApp.directive('catctrl', function(){
    return {
        restrict: 'E',
        transclude: true,
        scope: {rel:'=rel',title:'=title'},
        controller: 'catctrlCtrl',
        templateUrl: 'views/cat-ctrl.html',
        replace: true
    };
});


synopassApp.directive('catedit', function(){
    return {
        require: '^?catctrl',
        restrict: 'E',
        replace: true,
        scope: {},
        controller: 'cateditCtrl',
        link: function(scope, element, attrs, catctrlCtrl, Category){
            //catctrlCtrl.attachPopup(scope);

        },
        templateUrl: 'views/cat-edit.html',
        transclude: true
    };
});

synopassApp.directive('catadd', function(){
    return {
        restrict: 'E',
        scope: {},
        templateUrl: 'views/cat-add.html',
        replace: true,
        controller: 'cataddCtrl'
    };
});

synopassApp.directive('catdel', function(){
    return {
        require: '^?catctrl',
        restrict: 'E',
        replace: true,
        scope: {},
        controller: 'catdelCtrl',
        link: function(scope, element, attrs, catctrlCtrl, Category){
        },
        templateUrl: 'views/cat-del.html',
        transclude: true
    };
});

synopassApp.directive('ctxctrl', function(){
    return {
        restrict: 'E',
        transclude: true,
        scope: {rel:'=rel', title:'=title'},
        controller: 'ctxctrlCtrl',
        templateUrl: 'views/ctx-ctrl.html',
        replace: true
    };
});

synopassApp.directive('ctxedit', function(){

    return {
        require: '^?ctxctrl',
        restrict: 'E',
        replace: true,
        scope: {},
        controller: 'ctxeditCtrl',
        compile: function(scope, element, attrs, ctxctrlCtrl, Context){

        },
        link: function(scope, element, attrs, ctxctrlCtrl, Context){

            //catctrlCtrl.attachPopup(scope);

        },
        templateUrl: 'views/ctx-edit.html',
        transclude: true
    };
});

synopassApp.directive('ctxdel', function(){
    return {
        require: '^?ctxctrl',
        restrict: 'E',
        replace: true,
        scope: {},
        controller: 'ctxdelCtrl',
        link: function(scope, element, attrs, ctxctrlCtrl, Context){
        },
        templateUrl: 'views/ctx-del.html',
        transclude: true
    };
});

synopassApp.directive('ctxadd', function(){
    return {
        restrict: 'E',
        scope: {},
        templateUrl: 'views/ctx-add.html',
        replace: true,
        controller: 'ctxaddCtrl'
    };
});

synopassApp.directive('pwdctrl', function(){
    return {
        restrict: 'E',
        transclude: true,
        scope: {rel:'=rel',title:'=title',obj:'=obj'},
        controller: 'pwdctrlCtrl',
        templateUrl: 'views/pwd-ctrl.html',
        replace: true
    };
});

synopassApp.directive('pwdedit', function(){

    var checkDuplicatedTag = function(tagList,tag){
        var isDuplicated = false;
        angular.forEach(tagList, function(tag1){
            if(tag1.toUpperCase() == tag.toUpperCase()){
                isDuplicated = true;
                return false;
            }
        });
        return isDuplicated;
    }
    return {
        require: '^?pwdctrl',
        restrict: 'E',
        replace: true,
        controller: 'pwdeditCtrl',

        link: function(scope, element, attrs, pwdctrlCtrl, Password){
            $(".ULTags").tagit({
                afterTagAdded: function(evt, ui){
                        var isDuplicated = false;

                        isDuplicated=checkDuplicatedTag(scope.tagList,ui.tagLabel);

                        if(isDuplicated){
                            alert('Duplicate tag. Tag will be removed');
                            $(".ULTags").tagit("removeTagByLabel", ui.tagLabel);
                            return false;
                        }

                },
                itemName: 'editTags',
                fieldName: 'editTags'
            });


        },
        templateUrl: 'views/pwd-edit.html',
        transclude: true
    };
});

function checkDuplicateTag(tagList, tag){

}
synopassApp.directive('pwddel', function(){
    return {
        require: '^?pwdctrl',
        restrict: 'E',
        replace: true,
        scope: {title:'=title', rel:'=rel'},
        controller: 'pwddelCtrl',
        link: function(scope, element, attrs, pwdctrlCtrl, Password){


        },
        templateUrl: 'views/pwd-del.html',
        transclude: true
    };
});

synopassApp.directive('pwdadd', function(){
    return {
        restrict: 'E',
        scope: {},
        templateUrl: 'views/pwd-add.html',
        replace: true,
        controller: 'pwdaddCtrl',
        link: function(scope, element, attrs){

            var tid = "#ULTagsNew";

            $(tid).tagit({
                itemName: 'newTags',
                fieldName: 'newTags'
            });


        }

    };
});

synopassApp.directive('setup', function(){
    return {
        restrict: 'E',
        transclude: true,
        scope: {},
        controller: 'setupCtrl',
        templateUrl: 'views/setup.html',
        replace: true
    };
});

synopassApp.directive('login', function(){
    return {
        restrict: 'E',
        transclude: true,
        scope: {},
        controller: 'loginCtrl',
        templateUrl: 'views/login.html',
        replace: true
    };
});

synopassApp.directive('httpwarning', function(){
    return {
        restrict: 'E',
        transclude: true,
        scope: {},
        controller: 'httpWarningCtrl',
        templateUrl: 'views/http-warning.html',
        replace: true
    };
});
