<?php
//Login
$app->post('/login_two_factor', function () {

	
    sanitize($_POST,array('json' => 'str'));
	$json	= $_POST['json'];

    $error = array();

	check_json($json);

	$auth = new Auth();

	$param = json_decode($json);

	if(
		empty($param->{'p'}) ||
		empty($param->{'c'})
	){
		missing_parameter();
		die;
	}

	$login_count = block_failed_login();
	
	$result = $auth->login($param->{'p'});

	
	
	if($result === true){
		$enc_key = get_encryption_key($param->{'p'});
		$code_result = $auth->verify_code($enc_key,$param->{'c'});
		
		if($code_result){
			push_password_view($enc_key, "Login success " . $date = date('Y-m-d H:i:s'));
			
			$config = new Config();
			$nonce = $config->create_nonce();
			
			$cfg = $config->get($enc_key);
		
			$error = array('response' => 1, 'err_code' => 0, 'nonce' => $nonce);
			
			$gcm_on = false;

			foreach ($cfg as $key => $value) {
				$is_gcm_is_enabled=false;
				$is_gcm_sender_id=false;
				$is_gcm_api_key=false;
				$is_gcm_reg_id=false;
				$is_gcm_reg_id_retrieve_email=false;
				$is_gcm_reg_id_email=false;
				foreach($value as $key=>$v){
					if($key == 'key'){
						if($v == "gcm_is_enabled")
							$is_gcm_is_enabled=true;
						else if($v == "gcm_sender_id")
							$is_gcm_sender_id=true;
						else if($v == "gcm_api_key")
							$is_gcm_api_key=true;
						else if(strpos($v,'gcm_reg_id_') !== false)
							$is_gcm_reg_id=true;
						else if($v == "gcm_email_reg_id_flag")
							$is_gcm_reg_id_retrieve_email=true;
						else if($v == "gcm_reg_id_email")
							$is_gcm_reg_id_email=true;
					}else if($key == 'value'){
						if($is_gcm_is_enabled){
							$error['gcm_is_enabled']=$v;
							if($v == "1")
								$gcm_on=true;
						}else if($is_gcm_sender_id){
							$error['gcm_sender_id']=$v;
						}else if($is_gcm_api_key){
							//$error['gcm_api_key']=$v;
						}else if($is_gcm_reg_id) {
							$error['gcm_reg_id']=$v;
						}else if($is_gcm_reg_id_retrieve_email) {
							$error['gcm_reg_id_is_email']=$v;
						}else if($is_gcm_reg_id_email) {
							$error['gcm_reg_id_email']=$v;
						}
					}
				}
			}

			if($gcm_on){
				if($config->count_reg_id() < 1)
					$error['need_reg_id']="1";
			}
		}else{
			push_password_view($enc_key, "Login failed(invalid code) " . $date = date('Y-m-d H:i:s'));
			increment_fail_login($login_count);
			$error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'invalid code');
		}
	}else{
		increment_fail_login($login_count);
        $error = array('response' => 0, 'err_code' => $result, 'err_desc' => 'login failed');
    }
    echo json_encode($error);

});
?>